/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the ScriptsList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ScriptsList{}

// ScriptsList struct for ScriptsList
type ScriptsList struct {
	Results []Script `json:"results,omitempty"`
	Total *int64 `json:"total,omitempty"`
}

// NewScriptsList instantiates a new ScriptsList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewScriptsList() *ScriptsList {
	this := ScriptsList{}
	return &this
}

// NewScriptsListWithDefaults instantiates a new ScriptsList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewScriptsListWithDefaults() *ScriptsList {
	this := ScriptsList{}
	return &this
}

// GetResults returns the Results field value if set, zero value otherwise.
func (o *ScriptsList) GetResults() []Script {
	if o == nil || IsNil(o.Results) {
		var ret []Script
		return ret
	}
	return o.Results
}

// GetResultsOk returns a tuple with the Results field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptsList) GetResultsOk() ([]Script, bool) {
	if o == nil || IsNil(o.Results) {
		return nil, false
	}
	return o.Results, true
}

// HasResults returns a boolean if a field has been set.
func (o *ScriptsList) HasResults() bool {
	if o != nil && !IsNil(o.Results) {
		return true
	}

	return false
}

// SetResults gets a reference to the given []Script and assigns it to the Results field.
func (o *ScriptsList) SetResults(v []Script) {
	o.Results = v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *ScriptsList) GetTotal() int64 {
	if o == nil || IsNil(o.Total) {
		var ret int64
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptsList) GetTotalOk() (*int64, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *ScriptsList) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int64 and assigns it to the Total field.
func (o *ScriptsList) SetTotal(v int64) {
	o.Total = &v
}

func (o ScriptsList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ScriptsList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Results) {
		toSerialize["results"] = o.Results
	}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	return toSerialize, nil
}

type NullableScriptsList struct {
	value *ScriptsList
	isSet bool
}

func (v NullableScriptsList) Get() *ScriptsList {
	return v.value
}

func (v *NullableScriptsList) Set(val *ScriptsList) {
	v.value = val
	v.isSet = true
}

func (v NullableScriptsList) IsSet() bool {
	return v.isSet
}

func (v *NullableScriptsList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableScriptsList(val *ScriptsList) *NullableScriptsList {
	return &NullableScriptsList{value: val, isSet: true}
}

func (v NullableScriptsList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableScriptsList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


